/*
 *  Smart Cache , http proxy caching server
 *  Copyright (C) 1998-9 Radim Kolar <hsn@cybermail.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA or
 *  download copy from http://www.gnu.org/copyleft/gpl.html
 *
 */

import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;


/* bugs */
/* nepodporuje multi-line hlavicky. Pouziva to vubec nekdo? */
/* turn off cache file je neefektivni (neodstranuje lf ze seznamu) */

public final class httpreq implements Runnable
{

public static final int REQUEST_GET=1;
public static final int REQUEST_POST=2;
public static final int REQUEST_HEAD=3;
public static final int REQUEST_MIN=REQUEST_GET;
public static final int REQUEST_MAX=REQUEST_HEAD;
public static mgr mgr;
public static String visible_hostname;
public static int client_timeout;

public static DateFormat formatter= new SimpleDateFormat("dd/MMM/yyyy:HH:mm:ss", Locale.US);

/* access.log */
public static String logpatterns[];
public static DataOutputStream logfilez[];
public static String logfilenames[];

   private Socket socket = null;

    httpreq(Socket socket) {
        this.socket=socket;
    }
        
 final public void run() {
    boolean http10=true;
    try { DataInputStream in=new DataInputStream (new BufferedInputStream(socket.getInputStream()));
         DataOutputStream ou=new DataOutputStream(new BufferedOutputStream(socket.getOutputStream()));
         
    /* precteme radku GET / */
    
    socket.setSoTimeout(client_timeout);
    
    String req=in.readLine();
    if(req==null) { socket.close();ou.close();return;}
    String req2=null;
    int req_method=0;
    Vector headers=new Vector();
   
    /* zpracujeme request */
    if (req.indexOf(" HTTP/",0)==-1) http10=false;
                                     
    /* najdeme metodu a request */   
    
    StringTokenizer st=new StringTokenizer(req);
    try{
    req2=st.nextToken();
    
    if(req2.equals("GET")) req_method=REQUEST_GET;
    else
    if(req2.equals("POST")) req_method=REQUEST_POST;
    else
    if(req2.equals("HEAD")) req_method=REQUEST_HEAD;
    else
     server_error(http10,501,"Method "+req+" not implemented.",ou);
    
    req2=st.nextToken();

//    System.out.println("req2="+req2); 
    }
    catch (NoSuchElementException e) { server_error(http10,400,"Incomplete request",ou);}
        
    /* HTTP 1.0+ - musime precist zbytek volovin az do prazdne radky */    
    
    if(http10)  while(true)
                   { req=in.readLine();
                     if(req==null) break;
                     if(req.length()==0) break;
                     headers.addElement(req);
               //    System.out.println("adding "+req);
                    }
                    
     /* zaciname zpracovavat requesty */
     request rq;
     try{
     if (http10) rq=new request(req_method,req2,headers,in,ou);
       else
        rq=new request(req_method,req2,null,in,ou);
     
         
     // System.out.println("RQ");
     
     /* zalogovat do access.logu */
     if(logpatterns!=null)
      {
       int j=logpatterns.length;
       String urlcache=rq.getURL();
       for(int i=0;i<j;i++)
        {
        String fragment;
        fragment=mgr.simpleWildMatch(logpatterns[i], urlcache);
        if(fragment==null) continue;
        DataOutputStream outfile;
        outfile=logfilez[i];
          
           if(outfile==null && logfilenames[i]!=null)
           /* OPEN LOGFILE */
            if(!open_logfile(logfilenames,logfilez,i)) break;
             else
              outfile=logfilez[i];
             
            
          /* ZAHAJUJEME LOGOVANI ! */  
          InetAddress adr;
          adr=socket.getInetAddress();
          // DataOutputStream log;
          StringBuffer sb=new StringBuffer(80);
          
          sb.append(adr.getHostAddress());
          // log.writeBytes(adr.getHostAddress());
          sb.append(" - - [");
          // log.writeBytes(" - - [");
          sb.append(formatter.format(new Date()));
          // log.writeBytes(formatter.format(new Date()));
          sb.append(" +0200] ");
          // log.writeBytes(" +0200] ");
          switch(req_method)
          {
           case REQUEST_GET: sb.append("GET ");break;
           case REQUEST_POST: sb.append("POST ");break;
           case REQUEST_HEAD: sb.append("HEAD ");break;
          }
          if(logpatterns[i]==null) sb.append(fragment+" 200 0\n");
             else
          sb.append("/"+fragment+" 200 0\n");
          synchronized (outfile)
          {
            outfile.writeBytes(sb.toString());
          }
          
          // log.flush();
       } /* log for */
      }/* log enabled? */
     /* dodelej request , premapuj a proved */
     try
      {
        mgr.process_request(rq);
      }
      catch (IOException transfer_error)
      { socket.setSoLinger(true,10*1000); }
     }
     catch(MalformedURLException e2) { server_error(http10,400,"Invalid URL syntax",ou);}
                   
     // System.out.println(headers);
     ou.close();
     in.close();
     socket.close();
    }
    catch (IOException e)
    {   // e.printStackTrace();
    }
    
     /* zkusime zavrit socket */
     
     try {
     socket.close();} catch (IOException e) {};
     socket=null;
     return;
    }   
    
final public static void server_error(boolean http10,int errorrc,String msg,
 DataOutputStream ou) throws IOException
 {
   StringBuffer sb=new StringBuffer(1024);
   if(http10) { sb.append("HTTP/1.0 "+errorrc+" ERROR\r\nContent-type: text/html\r\nLast-Modified: "+request.printDate(new Date())+
                "\r\nDate: "+request.printDate(new Date())+
                "\r\nExpires: "+request.printDate(new Date( new Date().getTime()+5*60*1000L ))+
                "\r\nServer: "+scache.VERSION+"\r\nConnection: close\r\nProxy-Connection: close\r\n\r\n");
              }
   sb.append("<h2>"+errorrc+" "+msg+"</h2>\r\n<hr noshade size=1>Generated by "+visible_hostname+" (<a href=\"http://ncic.netmag.cz/apps/nase/smartcache.html\">"+scache.VERSION+"</a>)");
    
   ou.writeBytes(sb.toString());
   ou.close();
   throw new IOException("Request processing canceled");
 
}

/* pokusi se otevrit protokolacni soubor */

public final static boolean 
  open_logfile(String xlogfilenames[], DataOutputStream xlogfilez[], int i)
{
           /* OPEN LOGFILE */
            {
             try{
             DataOutputStream dos;
             RandomAccessFile ras;
             ras=new RandomAccessFile(xlogfilenames[i],"rw");
             ras.seek(ras.length());
             dos=new DataOutputStream(new BufferedOutputStream(
             new FileOutputStream(ras.getFD()),4096));
             xlogfilez[i]=dos;
             }
             catch (IOException e1)
              {
               System.err.println("Problem creating logfile "+xlogfilenames[i]+" - turning it off");
               xlogfilenames[i]=null;
               return false;
              }
            } /* logfile open */
  return true;
}

public final static void flush(DataOutputStream xlogfilez[])
{
 
 if(xlogfilez!=null)
   for(int z=0;z<xlogfilez.length;z++)
   {
     if(xlogfilez[z]!=null)
       try{
        xlogfilez[z].flush();
       }
       catch(IOException e)
       {}
   }
}


public final static void close(DataOutputStream xlogfilez[])
{
 
 if(xlogfilez!=null)
   for(int z=0;z<xlogfilez.length;z++)
   {
     if(xlogfilez[z]!=null)
       try{
        xlogfilez[z].close();
       }
       catch(IOException e)
       {}
       finally
       {
        xlogfilez[z]=null;
       }
   }
}



} /* class */