/*
 *  Smart Cache , http proxy caching server
 *  Copyright (C) 1998-9 Radim Kolar <hsn@cybermail.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA or
 *  download copy from http://www.gnu.org/copyleft/gpl.html
 *
 */

import java.io.*;
import java.util.*;
import java.text.*;
import java.util.zip.*;
import java.net.*;

public final class mgr implements Runnable{

public static final String DEFAULTNAME=".welcome";
/* cache manager */
public static InetAddress parentproxy;
public static int port; // parentproxyport

private static int ourport;
private static InetAddress ouraddress;

private static final long SAVETIMER=1000L*60*3;
private static String cache_dir;
private static String custom403;
private static int swap_level1_dirs= 4;
private static int swap_level2_dirs= 4;
public  static String[] no_proxy;
public  static String[] allow_cookies_to;
public static boolean case_sensitive;

private  static String AdID,AdAuth;

/* rulez */
private  static  boolean cacheonly;
private  static  regexp[] fail;
private  static  regexp[] nocache;
private  static  regexp[] pass;

private  static  long pass_timestamp;
private  static  long fail_timestamp;
private  static  long cookie_timestamp;

private  static  String cookie_filename;
private  static  String pass_filename;
private  static  String fail_filename;

private  static  boolean reload_block_files;

/* refresh strategy */
private  static regexp[] refresh;
private  static long minage[];
private  static long maxage[];
private  static long reloadage[];
private  static float lastmodf[];

private  static String[] redirfrom;
private  static String[] redirto;

private  static AdBuster ad;

private  static Hashtable dircache;
private  static long min_age;
private  static long max_age;
private  static long reload_age;
private  static float lmfactor;
private  static String shutdownflag,immediate_shutdownflag;

mgr()
{
 dircache=new Hashtable(25);
 /* init to some defaults */
 /* static intit */
 request.formatter.setTimeZone(TimeZone.getTimeZone("GMT")); 
 
 SimpleTimeZone tz;
 // System.err.println("TZOFFSET="+new Date().getTimezoneOffset());
// tz=new SimpleTimeZone(2*60*1000,TimeZone.getAvailableIDs(2*60*1000)[0]);

 httpreq.formatter.setTimeZone(TimeZone.getDefault());
 
 /* defaults */
 // registered=false;
 cacheonly=false;
 cache_dir="store";
 reload_block_files=false;
 
 port=3128; /* default parent proxy port */
 ourport=8080; /* lepe se pamatuje */
 request.default_forward_for="127.0.0.1";
 swap_level1_dirs= swap_level2_dirs=4;
 lmfactor=0.2f;
 min_age=15*60*1000L; /* 15 minut */
 max_age=4*24*60*60*1000L; /* 4 dny */
 /* quick abort disable */
 request.qa_minlen=-1;
 /* max luxovaci cas 3 minuty */
 request.qa_maxtime=3*60*60*1000L;
 httpreq.client_timeout=30*1000;
 request.read_timeout=5*60*1000;
 cacheobject.keep_deleted=false;
 cacheobject.generate_lastmod=0;
 cacheobject.hide_errors=false;
 cacheobject.defaultname=DEFAULTNAME; // UGLY CERN standard
 request.remove_pragma_no_cache=false;
 request.referer_hack=0; 
 request.fake_referer=null;
 request.fake_user_agent=null;
 request.full_referer_log=true;
 request.cache_protected=false; 
 case_sensitive=false;
 httpreq.visible_hostname="smart.cache.lan";

}

/* tady se to spousti!!!*/
public void go() throws IOException
{
 System.err.println("Checking filesystem");
 // case_sensitive=caseSensitiveFilesystem();
 // System.out.println("   Case sensitive matching: "+case_sensitive);
 if(File.separator.equals("\\")) {
  System.err.println("   Backslash will be escaped.");
  cacheobject.escape_backslash=true;
  } else cacheobject.escape_backslash=false;
  
 cacheobject.end_dot=endDotFilesystem();
 System.err.println("   Allow dot at end filename: "+cacheobject.end_dot);
 scache daemon=new scache(ourport,ouraddress);
 new Thread(this).start(); /* spustit saver... */ 
 
 scache.faststart=true; 
  // NO BUSTERS AND LASTVERCHECK.  NO SERVER FOR HOSTING :(
  // SOME1 WANTS TO HOST IT?
  
 if(scache.faststart==false)
 {
 System.err.println("Checking for latest Smart Cache version");
 String lv=getLatestVersion();
 if (lv==null) lv="(Error connecting to server)";
 else if (!lv.equals(scache.CACHEVER)) lv+="\007 ... its time for update!";
   else
    lv+=" ... up to date";
 System.err.println("   Latest version is "+lv);
 }
 initAdBusters();
 
 /* refresh pattern hack */
 if(refresh!=null && !isInRegexpArray("*",refresh)) 
 {
  refresh=addRegexpToArray("*",refresh);
                      
  /* natahnout ! */
  reloadage=incLongArraySize(reloadage);
  minage=incLongArraySize(minage);
  maxage=incLongArraySize(maxage);
  lastmodf=incFloatArraySize(lastmodf);
                    
  /* nastavit hodnoty */
  reloadage[reloadage.length-1]=reload_age;
  minage[minage.length-1]=min_age;
  maxage[maxage.length-1]=max_age;
  lastmodf[lastmodf.length-1]=lmfactor;
 }
 
 System.out.println("\n"+new Date()+" "+scache.VERSION+" ready."); 
 // on port "+ourport+"/"+(ouraddress==null ? "*" : ouraddress.getHostAddress())+".");
 
 ouraddress=null; // GC IT!
 httpreq.mgr=this;  
 checkFlag(shutdownflag); // delete pending shutdown flag on start
 checkFlag(immediate_shutdownflag); // delete pending shutdown flag on start
 daemon.httpdloop();
}

private static String getLatestVersion()
{
 URL u=null;
 try
 {
      u=new URL("http://adbusters.netmag.cz:8001/cachever");
   // u=new URL("http://localhost:8001/cachever");
 }
 catch (MalformedURLException e)
  { return null;}
 String ver=null;
 try
 {
 ver=new DataInputStream(u.openStream()).readLine();
 return ver;
 }
 catch (IOException e)
  { return null;}
 
}

private void initAdBusters()
{
 if(AdID==null || AdAuth==null) return;
 System.err.println("Initializing cache in AdBusters mode");
 try
 {
  URL u;
  if(scache.faststart==true)
  u=new URL("http://127.0.0.1:8001/AdBuster?id="+AdID+"&auth="+AdAuth+"&e");  
    else
  u=new URL("http://adbusters.netmag.cz:8001/AdBuster?id="+AdID+"&auth="+AdAuth+"&e");
  
// u=new URL("http://localhost:8001/AdBuster?id="+AdID+"&auth="+AdAuth+"&e");
  
  ObjectInputStream ois=null; 
  try{
  ois =
                    new ObjectInputStream(u.openStream());
                    ad = (AdBuster)ois.readObject();

                          
                        }
                        catch (Throwable e) {
                                System.err.println("   *ERR "+e);
                        }
                        finally
                         {
                             if(ois!=null) try{ois.close();}
                                            catch(IOException e) {};
                             ois=null;
                         }
 if(ad!=null) { System.err.println("   Refreshed rules list from server");
                mergeBusters(); 
                ad=null; 
                return;}

 
 /* ze souboru */
  try{
  ois =
                    new ObjectInputStream(new FileInputStream("AdBuster.ser"));
                    ad = (AdBuster)ois.readObject();

                          
                        }
                        catch (Throwable e) {
                                System.err.println("  *ERR "+e);
                        }
                        finally
                         {
                             if(ois!=null) try{ois.close();}
                                            catch(IOException e) {};
                             ois=null;
                         }
                         
 if(ad!=null) { System.err.println("   Rules list loaded from local backup copy");mergeBusters(); ad=null; return;}
 }
 catch (MalformedURLException e)
  {}
}

private void mergeBusters()
{
 if(ad==null) return;
 
 /* save! */
                         try {
                                BufferedOutputStream bos = new BufferedOutputStream
                                    (new FileOutputStream("AdBuster.tmp"));
                                ObjectOutputStream oos =
                                    new ObjectOutputStream(bos);
                                oos.writeObject(ad);
                                oos.close();                                
                                bos.close();
                                /* prejmenovat na .ser */
                                File f=new File("AdBuster.tmp");
                                File f2=new File("AdBuster.ser");
                                if(!f2.delete()) { System.err.println("   Delete old savefile failed.");}
                                if(false==f.renameTo(f2)) { System.err.println("   Rename to new savefile failed");}
                        }
                        catch (Throwable e) {
                                System.err.println("error when saving: "+e);
                        }
  for(int i=0;i<ad.allow.length;i++)
   pass=addRegexpToArray(ad.allow[i],pass);

  for(int i=0;i<ad.fail.length;i++)
   fail=addRegexpToArray(ad.fail[i],fail);
      
   
  System.err.println("   Ad Busters mode init done.");
  scache.VERSION=scache.CACHENAME+" "+scache.CACHEVER+" in Ad Busters mode";

}
/*
private boolean caseSensitiveFilesystem()
{
 (new File(cache_dir)).mkdirs();
 try{
 new FileOutputStream(cache_dir+File.separator+"casecheck").close();
 }
 catch (IOException e1) {return false;}
 boolean r=!new File(cache_dir+File.separator+"cAsEcHeCk").exists();
 new File(cache_dir,"casecheck").delete();
 return r;
}
*/
private final boolean endDotFilesystem()
{
 (new File(cache_dir)).mkdirs();
 try{
 new FileOutputStream(cache_dir+File.separator+"dot.").close();
 }
 catch (IOException e1) {return false;}
 
 File d=new File(cache_dir);
 String names[]=d.list();
 new File(cache_dir,"dot.").delete();
  
 for(int i=0;i<names.length;i++)
  {
   if(names[i].toLowerCase().equals("dot.")) return true;
  }

 return false;
}

public final void read_config(String cfgfile)
{
 try{
 String line,token;
 StringTokenizer st;
 int lineno=0;
 DataInputStream dis=new DataInputStream(new BufferedInputStream(new FileInputStream(cfgfile))); 
 while ( (line = dis.readLine()) != null)
 {
      lineno++;
      if(line.startsWith("#")) continue;
      st=new StringTokenizer(line);
      if(st.hasMoreTokens()==false) continue;
      token=st.nextToken();
      try
      {
          
          if(token.equalsIgnoreCase("visible_hostname")) {httpreq.visible_hostname=st.nextToken();
          					    continue;
                                                    }
          if(token.equalsIgnoreCase("default_forward_for")) {request.default_forward_for=st.nextToken();
          					    continue;
                                                    }
                                                    
          if(token.equalsIgnoreCase("adbustersid")) {AdID=st.nextToken();
          					    continue;
                                                    }
                                                    
          if(token.equalsIgnoreCase("adbustersauth")) {AdAuth=st.nextToken();
          					    continue;
                                                    }
                                                    
         if(token.equalsIgnoreCase("defaultname")) {cacheobject.defaultname=st.nextToken();
          					    continue;
                                                    }

         if(token.equalsIgnoreCase("allow_cookies_to")) 
                                                    {
                                                     while(st.hasMoreTokens())
                                                     {
                                                      String z;
                                                      z=st.nextToken().toLowerCase();
                                                      if(z.equals("all")) { allow_cookies_to=null;break;}
                                                      allow_cookies_to=addStringToArray(z,allow_cookies_to);
                                                     }
          					     continue;
                                                    }
                                                                                                        

          if(token.equalsIgnoreCase("bindaddress")) {
                                                    // if(!registered) continue;
                                                    String ip=st.nextToken();
                                                    if(ip.equals("*")) { ouraddress=null;continue;}
                                                    try{
                                                    ouraddress=InetAddress.getByName(ip);
                                                    }
                                                    catch (IOException e) { System.err.println("Can not resolve my BindAddress: "+ip);}
          					    continue;
                                                    }
                                                                                                        
                                                    
          if(token.equalsIgnoreCase("shutdown_flag")) {shutdownflag=st.nextToken();
          					    continue;
                                                    }
          if(token.equalsIgnoreCase("immediate_shutdown_flag")) {immediate_shutdownflag=st.nextToken();
          					    continue;
                                                    }
                                                    
          if(token.equals("case_sensitive_matching")) {
          				                   char c=(char)Integer.valueOf(st.nextToken()).intValue();
                                                           if(c==1) case_sensitive=true; else case_sensitive=false;
                                                           continue;
                                                      }
                                                    
          if(token.equalsIgnoreCase("cacheroot")) {cache_dir=st.nextToken();
          					    continue;
                                                    }
                                                    
          if(token.equalsIgnoreCase("port")) {ourport=Integer.valueOf(st.nextToken()).intValue();
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("referer_hack")) {
                                                     String rh=st.nextToken();
                                                    try
                                                      {
				                       request.referer_hack=(char)Integer.valueOf(rh).intValue();
                                                      }
                                                    catch (NumberFormatException e)
                                                     {
                                                      request.fake_referer=rh;
                                                     }
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("fake_referer")) {
                                                     String rh=st.nextToken();
                                                     request.fake_referer=rh;
                                                     
          					    continue;
                                                    }
                                                                                                        
                                                    
          if(token.equalsIgnoreCase("swap_level1_dirs")) {swap_level1_dirs=Integer.valueOf(st.nextToken()).intValue();
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("swap_level2_dirs")) {swap_level2_dirs=Integer.valueOf(st.nextToken()).intValue();
          					    continue;
                                                    }
          if(token.equalsIgnoreCase("http_proxy")) {setproxy(st.nextToken(),Integer.valueOf(st.nextToken()).intValue());
          					    continue;
                                                    }
          if(token.equalsIgnoreCase("access_log")) {
                                                    // if(!registered) continue;
                                                    String mask=st.nextToken();
                                                    if(mask.equals("*")) mask=null;
          
                                                    httpreq.logpatterns=addStringToArray(mask,httpreq.logpatterns);
                                                    httpreq.logfilenames=addStringToArray(st.nextToken(),httpreq.logfilenames);
                                                    
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("agent_log")) {
                                                    // if(!registered) continue;
                                                    String mask=st.nextToken();
                                                    if(mask.equals("*")) mask=null;
          
                                                    request.alogpatterns=addStringToArray(mask,request.alogpatterns);
                                                    request.alogfilenames=addStringToArray(st.nextToken(),request.alogfilenames);
                                                    
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("referer_log")) {
                                                    // if(!registered) continue;
                                                    String mask=st.nextToken();
                                                    if(mask.equals("*")) mask=null;
          
                                                    request.rlogpatterns=addStringToArray(mask,request.rlogpatterns);
                                                    request.rlogfilenames=addStringToArray(st.nextToken(),request.rlogfilenames);
                                                    
          					    continue;
                                                    }
                                                                                                                                                            
                                                    

          if(token.equalsIgnoreCase("no_proxy"))   {
                                                    while(st.hasMoreTokens())
                                                      no_proxy=addStringToArray(st.nextToken().toLowerCase(),no_proxy);
          					    continue;
                                                    }
          if(token.equalsIgnoreCase("serialnumber")) {
                                                    /* Look at my very secure registration keys checker */
                                                    
                                                    // if(st.nextToken().startsWith("HTTP")) registered=true;
                                                    // else
                                                    //System.out.println("\t\007WARNING: Invalid serial number entered!");
                                                    // registered=true;
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("fail")) {     while(st.hasMoreTokens())
                                                      fail=addRegexpToArray(st.nextToken(),fail);
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("fail_file")) {
                                                    String fn=st.nextToken();
                                                    fail=parseRegexpFile(fn,fail);
                                                    fail_timestamp=new File(fn).lastModified();
                                                    fail_filename=fn;
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("allow_cookies_to_file")) {
                                                    String fn=st.nextToken();
                                                    allow_cookies_to=parseCookieFile(fn,allow_cookies_to);
                                                    cookie_timestamp=new File(fn).lastModified();
                                                    cookie_filename=fn;
          					    continue;
                                                    }
                                                    
          if(token.equalsIgnoreCase("pass_file")) {
                                                    String fn=st.nextToken();
                                                    pass=parseRegexpFile(fn,pass);
                                                    pass_timestamp=new File(fn).lastModified();
                                                    pass_filename=fn;
          					    continue;
                                                    }
                                                                                                        
          if(token.equalsIgnoreCase("nocaching")) { while(st.hasMoreTokens())
                                                       nocache=addRegexpToArray(st.nextToken(),nocache);
                                                    cacheonly=false;
          					    continue;
                                                    }

          if(token.equalsIgnoreCase("fake_user_agent")) {request.fake_user_agent="User-Agent:"+st.nextToken("\n");
          					         continue;
                                                        }

          if(token.equalsIgnoreCase("wafer")) {request.wafer="Cookie:"+st.nextToken("\n");
          					         continue;
                                              }
                                                                                                                                                                

          if(token.equalsIgnoreCase("pass"))      {while(st.hasMoreTokens())
                                                    pass=addRegexpToArray(st.nextToken(),pass);
          					   continue;
                                                   }
                                                    
          if(token.equalsIgnoreCase("cacheonly")) {while(st.hasMoreTokens())
                                                     nocache=addRegexpToArray(st.nextToken(),nocache);
                                                   cacheonly=true;
          					   continue;
                                                    }
                                                                                                        
                                                                                                        
          if(token.equalsIgnoreCase("redirect")) { redirfrom=addStringToArray(st.nextToken(),redirfrom);
                                                   redirto=addStringToArray(st.nextToken(),redirto);
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("quick_abort")) { 
                                                   request.qa_minlen=Integer.valueOf(st.nextToken()).intValue();          
                                                   request.qa_percent=Float.valueOf(st.nextToken()).floatValue();                                                   
                                                   request.qa_maxlen=Integer.valueOf(st.nextToken()).intValue();                                                             
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("errordocument")) { 
                                                   int code=Integer.valueOf(st.nextToken()).intValue();          
                                                   if(code==403) custom403=st.nextToken();
                                                    else if(code==400) cacheobject.custom400=st.nextToken();
                                                          else
                                                            System.err.println("[CONFIG_ERROR] "+cfgfile+":"+lineno+" Error code "+code+" is not customizable.");
          					   continue;
                                                   }
                                                                                                      

          if(token.equalsIgnoreCase("max_aborted_transfer_time")) { 
                                                   request.qa_maxtime=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("max_clients")) { 
                                                   scache.MAXHTTPCLIENTS=Integer.valueOf(st.nextToken()).intValue();
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("inputtimeout")) { 
                                                   httpreq.client_timeout=Integer.valueOf(st.nextToken()).intValue()*1000;
          					   continue;
                                                   }
          if(token.equalsIgnoreCase("proxyreadtimeout")) { 
                                                   request.read_timeout=Integer.valueOf(st.nextToken()).intValue()*1000;
          					   continue;
                                                   }
                                                   
                                                   
          if(token.equalsIgnoreCase("pragma_no_cache")) { 
                                                   request.pnocache=(char)Integer.valueOf(st.nextToken()).intValue();
          					   continue;
                                                   }
          if(token.equalsIgnoreCase("keep_deleted")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   if(z==1) cacheobject.keep_deleted=true; else
                                                    cacheobject.keep_deleted=false;
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("cache_password_protected")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   if(z==1) request.cache_protected=true; else
                                                    request.cache_protected=false;
          					   continue;
                                                   }
                                                   
          if(token.equalsIgnoreCase("remove_pragma_no_cache")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   if(z==1) request.remove_pragma_no_cache=true; else
                                                    request.remove_pragma_no_cache=false;
          					   continue;
                                                   }
 
         if(token.equalsIgnoreCase("reload_block_files")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   if(z==1) reload_block_files=true; else
                                                            reload_block_files=false;
          					   continue;
                                                   }
                                                                                                      
          if(token.equalsIgnoreCase("generate_lastmod")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   cacheobject.generate_lastmod=z;
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("hide_errors")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   if(z==1) cacheobject.hide_errors=true; else
                                                    cacheobject.hide_errors=false;
          					   continue;
                                                   }

          if(token.equalsIgnoreCase("full_referer_log")) { 
                                                   int z=Integer.valueOf(st.nextToken()).intValue();
                                                   if(z==1) request.full_referer_log=true; else
                                                    request.full_referer_log=false;
          					   continue;
                                                   }
                                                                                                                                                                                                            
                                                   
                                                                                                                                                                                                             
          if(token.equalsIgnoreCase("default_refresh_pattern")) 
                                                    {
                                                    reload_age=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
                                                    try{
                                                      min_age=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
                                                      }
                                                    catch (NumberFormatException f)
                                                    {
                                                         System.err.println("Syntax for default_refresh_pattern has changed. Read the docs!");
                                                         System.exit(1);
                                                    }  
                                                    
                                                    lmfactor=Float.valueOf(st.nextToken()).floatValue();
                                                    if(!st.hasMoreElements()) { 
                                                         System.err.println("Syntax for default_refresh_pattern has changed. Read the docs!");
                                                         System.exit(1);
                                                                              }
                                                    max_age=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
                                                    if(reload_age>min_age) reload_age=min_age/4;
                                                    if(max_age<=min_age) max_age=min_age+1000L*60L*60L*48L;
          					    continue;
                                                    }
          if(token.equalsIgnoreCase("refresh_pattern")) 
                                                    {
                                                    // if(!registered) continue;
                                                    String url=st.nextToken();
                                                    if(isInRegexpArray(url,refresh)) continue;
                                                    long xreload_age=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
                                                    long xmin_age=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
                                                    float xlmfactor=Float.valueOf(st.nextToken()).floatValue();
                                                    long xmax_age=Integer.valueOf(st.nextToken()).intValue()*1000L*60L;
                                                    if(xreload_age>xmin_age) xreload_age=xmin_age/4;
                                                    if(xmax_age<=xmin_age) xmax_age=xmin_age+1000L*60L*60L*48L;
                                                    /* pridat do pole */
                                                    refresh=addRegexpToArray(url,refresh);
                                                    /* natahnout ! */
                                                    reloadage=incLongArraySize(reloadage);
                                                    minage=incLongArraySize(minage);
                                                    maxage=incLongArraySize(maxage);
                                                    lastmodf=incFloatArraySize(lastmodf);
                                                    
                                                    /* nastavit hodnoty */
                                                    reloadage[reloadage.length-1]=xreload_age;
                                                    minage[minage.length-1]=xmin_age;
                                                    maxage[maxage.length-1]=xmax_age;
                                                    lastmodf[lastmodf.length-1]=xlmfactor;
          					    continue;
                                                    }
                                                    
                                                                                                                                                            
          System.out.println("[CONFIG_ERROR] Unknown keyword "+token+" in "+cfgfile+":"+lineno);  
     }
     catch (NoSuchElementException nse)
           { System.out.println("[CONFIG_ERROR] "+cfgfile+":"+lineno+" Missing arguent(s).");
             continue;}                                     
     catch (NumberFormatException nse)
           { System.out.println("[CONFIG_ERROR] "+cfgfile+":"+lineno+" Invalid Number Format.");
             continue;}                                     
             
     
 }/* while */
 dis.close();
   
 }
 catch(FileNotFoundException kiss)
  { System.out.println("[WARNING] No config file found. Using defaults.");}  
 catch(IOException e) 
  { System.out.println("I/O Error reading config file "+cfgfile);}
 
 // init access log filez 
 if(httpreq.logpatterns!=null) httpreq.logfilez=new DataOutputStream[httpreq.logpatterns.length];
 
 // init agent log filez 
 if(request.alogpatterns!=null) request.alogfilez=new DataOutputStream[request.alogpatterns.length];

 // init referer log filez 
 if(request.rlogpatterns!=null) request.rlogfilez=new DataOutputStream[request.rlogpatterns.length];
  
}

public void setproxy(String hostname,int port)
{
 try{
 parentproxy=InetAddress.getByName(hostname);
 this.port=port;
// System.out.println("My parent proxy is "+hostname+" port "+port);
 }
 catch (UnknownHostException e) 
  {
   System.err.println("Can not resolve parent proxy hostname: "+hostname+" - running without it.");
   parentproxy=null;
   this.port=0;
  }
}

final public void process_request(request req) throws MalformedURLException, IOException
{
 boolean allowed;
 allowed=false;

 String requested=req.getURL();
 
 /* HANDLE  REWRITE ! */
 if(redirfrom!=null)
  {
   String fragment;
   int j=redirfrom.length;
   for(int i=0;i<j;i++)
   {
    fragment=simpleWildMatch(redirfrom[i], requested);
    if(fragment==null) continue;
    if(is_wild(redirto[i])) 
     //req.make_headers(301,"text/html",redirto[i].substring(0,redirto[i].length()-1)+fragment,0,0,0);
       req.rewriteURL(redirto[i].substring(0,redirto[i].length()-1)+fragment);
     else
       // req.make_headers(301,"text/html",redirto[i],0,0,0);
       req.rewriteURL(redirto[i]);

    requested=req.getURL(); // reread URL
    break;          
   }
  } /* redir handler end */
 
 
 try
 {
 /* Zjistime zda mame URL radi! */
 if(pass!=null)
  {
  
   int j=pass.length;
   for(int i=0;i<j;i++)
    if(pass[i].matches(requested))
     { allowed=true;break;}
  }
 }
 catch (IndexOutOfBoundsException ignore) {}
 
 try
 {
 /* zda ho nemame radi! */ 
 if(fail!=null && allowed==false)
  {
  
   int j=fail.length;
   for(int i=0;i<j;i++)
   {
    if(fail[i].matches(requested))
     { 
       cacheobject.c_block++; //STAT
       if(custom403==null) req.send_error(403,"Forbidden by rule");
         else
            if(custom403.equals("-")) { 
                                       req.send_error(204,"No Content");  
                                       }
            else if(custom403.equals("!"))
              {
                 req.make_headers(200,"text/html",null,0,new Date().getTime(),0);
                 req.send_headers();
                 req.sendString("<HTML></HTML>");

              }                                       
                  else
                   { req.make_headers(301,null,custom403,0,new Date().getTime(),0);
                     req.send_headers();
                   }
                
       req.close();
       return;
       }
   }
  
  
  }
  
 }
 catch (IndexOutOfBoundsException ignore) {}
  
  /* NO-CACHE HANDLER */
    
  if(nocache!=null)
   { // if(cacheonly) req.nocache();
   
     int j=nocache.length;
     int i;
     
     toploop:while(true)
     {
     for(i=0;i<j;i++)
       {
         if(nocache[i].matches(requested))
           {
            if(!cacheonly) req.nocache();
            break toploop;              
           }
       } /* for */
         if(cacheonly) req.nocache();    
         break;   
      } /* toploop */
   }
   
 String[] parsed=parseURL(requested,req.getProtocol());
 String host=parsed[0];
 req.addHost(host,parsed[1]); /* pridat Host: hlavicku */

 try
 {
 /* C00KIES FILTER */
 if(allow_cookies_to!=null)
  {
   cookieloop:while(true)
   {
    for(int i=allow_cookies_to.length-1;i>=0;i--)
     if(host.endsWith(allow_cookies_to[i])) { break cookieloop;}
   
   req.removeCookies();
   break;
   }
  }
 }
 catch (IndexOutOfBoundsException ignore) {}
  
 /* VELKA MASKARADA S PARENT PROXY SERVEREM */
 if(parentproxy==null) {
 /* DIREKT REZIM - klidek */
 
 try{
   req.setTarget(InetAddress.getByName(host),parsed[1]==null? 80: Integer.valueOf(parsed[1]).intValue());
 }
 catch (UnknownHostException e) { req.setTarget(null,80); }
 
 /* premenime request na normal */
 if(parsed[4]!=null) req.send_error(501,"Protocol "+parsed[4]+" is not directly supported.");
 req.setRequestTo(parsed[2]+parsed[3]);
 }
 else
 {
 /* jedeme skrz proxy */
 req.setTarget(parentproxy,port);
 /* podivame se jestli bychom radsi nemeli ject direkt */
 if(no_proxy!=null)
   {
   int j=no_proxy.length;
   for(int i=0;i<j;i++)
   {
    if(host.endsWith(no_proxy[i]))
                        {
                         /* bude to direct */
                         try{
                          req.setTarget(InetAddress.getByName(host),parsed[1]==null? 80: Integer.valueOf(parsed[1]).intValue());
                          /* asi to proslo, transformace requestu */
                          if(parsed[4]!=null) req.send_error(501,"Protocol "+parsed[4]+" is not directly supported.");
                          req.setRequestTo(parsed[2]+parsed[3]);
                            }
                         catch (UnknownHostException e) 
                           { /* no tak prece jenom zkusime jeste ten proxy server */ }
                        
                         break;
                        }
   }
   
   } /* if No_proxy */
 } 
 /* PARENT PROXY MASKARADA END! */
 
 /* testneme zda to neni post, ktery jede primo */
 if(req.getMethod()==httpreq.REQUEST_POST) { req.handle_post();
                                             return;
                                           }
 
 /* konverze na local dir */
 String locdir=getLocalDir(host,parsed[1],parsed[2],parsed[4]);
 // if(!case_sensitive) locdir=locdir.toLowerCase();
 cachedir dir=null;
 try{
      dir=getDir(locdir);
    }
 catch(Exception e) { e.printStackTrace();
                      System.out.println("Hostname:"+host);
                      System.out.println("Port:"+parsed[1]);
                      System.out.println("Dir:"+parsed[2]);
                      req.close();
                      return;
                    }
                      
 
 cacheobject cobj;
 cobj=dir.getObject(parsed[3]);
 
 /* HANDLE REFRESH PATTERNS MIN_AGE, PERCENT, MAX_AGE */
 if(refresh!=null)
  {
   int refreshcache=refresh.length;
   for(int i=0;i<refreshcache;i++)
    if(refresh[i].matches(requested))
     {
     cobj.make_request(req,reloadage[i],minage[i],maxage[i],lastmodf[i]);
     break;
     }
  
  }
  else
   cobj.make_request(req,reload_age,min_age,max_age, lmfactor);
 
 req.close();
}

final private synchronized cachedir getDir(String locdir)
{ 
 cachedir dir=(cachedir)dircache.get(locdir);
 if(dir!=null) return dir;

 dir=new cachedir(locdir); 
 dircache.put(locdir,dir);
 return dir;
}

final public void run()
{
 while(true)
 {
 
 try{
 Thread.sleep(SAVETIMER);
 }
 catch (InterruptedException e) { save();save();break;}
// System.out.println("saving...");
 save();
 }

}

/* Ulozi hashtabulku na disk */
final private void save()
{
 int saved=0;
 int cleaned=0;
 Enumeration e1=dircache.keys();
 Enumeration e2=dircache.elements();
 while(e1.hasMoreElements())
 {
  cachedir d;
  d=(cachedir) e2.nextElement();
  String key;
  key=(String) e1.nextElement();
  
  if(d.isDirty()) { d.save(); saved++;}
    else
                  { dircache.remove(key);
                    d.cleandir(); /* if needed */ 
//                  System.err.println("[DIRGC] "+key);
                    cleaned++;}
 
 }
 httpreq.flush(httpreq.logfilez);
 httpreq.flush(request.alogfilez);
 httpreq.flush(request.rlogfilez);
 
 if(saved>0)
 {
   System.out.println(new Date().toString()+" - REQS: "+cacheobject.c_hit+" Hit, "
   +cacheobject.c_refresh+" Refresh, "
   +cacheobject.c_miss+" Miss, "
   +cacheobject.c_block+" Block. Ratio="+
   (int)(
   100.0f*cacheobject.c_hit/((float)cacheobject.c_miss+cacheobject.c_hit+cacheobject.c_refresh)
   )
   +"%"
   );
   
   // clear the stats
   cacheobject.c_hit=cacheobject.c_miss=cacheobject.c_refresh=cacheobject.c_block
   =0;
 }
 if(cacheobject.b_miss+cacheobject.b_hit>0)
 {
   System.out.println(new Date().toString()+" - BYTES: "      
   +cacheobject.b_miss+" B in, "
   +(cacheobject.b_miss+cacheobject.b_hit)+" B out. Ratio="+
   (int)(
   100.0f*cacheobject.b_hit/((float)cacheobject.b_miss+cacheobject.b_hit)
   )
   +"%"
   );   
   
   // clear the stats
   cacheobject.b_hit=cacheobject.b_miss=0;
  }
 if(saved>0 || cleaned> 0) 
  {
   System.out.println(new Date().toString()+" - DIRS: "+saved+" saved, "+cleaned+" garbage collected.");
  }
 if(saved==0)
  { 
   httpreq.close(httpreq.logfilez);
   httpreq.close(request.alogfilez);
   httpreq.close(request.rlogfilez);   

   if(checkFlag(shutdownflag)) 
         { System.out.println(new Date()+" Cache stoped by shutdown flag");System.exit(0);}
  }
  if(checkFlag(immediate_shutdownflag))
   {
    e2=dircache.elements();
    while(e2.hasMoreElements())
    {
     cachedir d;
     d=(cachedir) e2.nextElement();
     d.cleandir(); /* if needed */ 
    }
   
     System.out.println(new Date()+" Cache stoped by immediate shutdown flag");System.exit(0);
   }
  
  
  // reloading block files
  if(reload_block_files==true)
   {
    if(pass_filename!=null)
     {
      if(new File(pass_filename).lastModified()!=pass_timestamp)
      {
       System.out.println(new Date()+" Reloading Pass_file "+pass_filename);
       pass=parseRegexpFile(pass_filename,null);
       pass_timestamp=new File(pass_filename).lastModified();
      }
     }

    if(fail_filename!=null)
     {
      if(new File(fail_filename).lastModified()!=fail_timestamp)
      {
       System.out.println(new Date()+" Reloading fail_file "+fail_filename);
       fail=parseRegexpFile(fail_filename,null);
       fail_timestamp=new File(fail_filename).lastModified();
      }
     }
        
    if(cookie_filename!=null)
     {
      if(new File(cookie_filename).lastModified()!=cookie_timestamp)
      {
       System.out.println(new Date()+" Reloading allow_cookies_to_file "+cookie_filename);
       allow_cookies_to=parseCookieFile(cookie_filename,null);
       cookie_timestamp=new File(cookie_filename).lastModified();
      }
     }
     
   } /* reload */
}

/*  prechrousta URL a vrati
0 - hostname
1 - port (if any) jinak null
2 - directory
3 - file including query string ("" if empty)
4 - protocol (null if http)
*/

final public static String[] parseURL(String url,String proto) throws MalformedURLException
{
  String[] res=new String[5];
  res[3]=""; /* HashTable je pitoma */
  int i,j;
  /* protocol check */
  res[4]=proto;
  int seven=proto.length()+3; /* '://' */
  
  if(seven==7)
   {
    char c;
    c=proto.charAt(0);
    if(c=='h' || c=='H') res[4]=null;
   }
  i=url.indexOf('/',seven);
  if(i==-1) { url+='/'; i=url.length()-1;}
  
  j=url.indexOf(':',seven);
  /* http://zero.dsd:434/ */
  if(j!=-1 && j<i)  /* mame tu portname */
                    {
                      res[0]=url.substring(seven,j);
                      res[1]=url.substring(j+1,i);
                      if(res[1].equals("80")) res[1]=null;
                    }
           else
             {
              res[0]=url.substring(seven,i);
             }

  /* parse adr */
  
  /* najdeme nejvice vlevo z moznych debilnich znaku */
  
  j=url.length()-1;

  /* stary kod */
  /*
  int pos;
  if((pos=url.indexOf('?',i))!=-1)
   { j=pos;}

  if((pos=url.indexOf(';',i))!=-1)
   { j=Math.min(pos,j);}

  if((pos=url.indexOf('=',i))!=-1)
   { j=Math.min(pos,j);}

  if((pos=url.indexOf(':',i))!=-1)
   { j=Math.min(pos,j);}
  */   
   
   /* new code */
   
   byte v[];
   v=new byte[j+1];
   url.getBytes(i,j+1,v,i);
   // getChars(i,j,v,0);
   loop1:for(int zz=i;zz<=j;zz++)
    {
    switch(v[zz])
    {
    case 0x3b: // ;
    case 0x3a: // :
    case 0x3d: // =
    case 0x3f: // ?
              j=zz;break loop1;
    case 0x23: // #
     url=url.substring(0,zz);break loop1;
    }
    }
      
    /* novy kod - konec! */
   
   j=url.lastIndexOf('/',j);

  res[2]=url.substring(i,j+1); // adresar
  if(j+1!=url.length()) res[3]=url.substring(j+1);
  
  return res;  
}

final public String getLocalDir(String host,String port,String urldir,String proto)
{
/***
Host - zero.vole.cz:3333
urldir = /ddfgfds/rerew/ - musi koncit s /
*/
  StringBuffer result=new StringBuffer(80);
  result.append(cache_dir);
  // String result=cache_dir;
  int i;
  
  /* 1. spocitat hash z host stringu */
  CRC32 crc=new CRC32();
  
  host=host.toLowerCase();  
  crc.update(host.getBytes());
                           
  /* mame hash - rozdelime ho na adresar */
  long unit=((long)1<<32)/(swap_level1_dirs*swap_level2_dirs);
//  System.out.println("unit="+unit);
//  System.out.println("crc="+crc.getValue());
  i=(int)(crc.getValue()/unit);
//  System.out.println("value="+i);  
  /* zacneme budovat cestu */
  result.append(File.separator+(i/swap_level2_dirs)+File.separator+(i-swap_level1_dirs*(i/swap_level2_dirs))+File.separator+host);

  /* pridame port */
  if(port!=null)
   {result.append('_');
    result.append(port);
   }

  /* add protocol */
  if(proto!=null) 
             {
              result.append('^');
              result.append(proto);
             }
  
  /* pridame adresar */
  if(File.separatorChar!='/') urldir=urldir.replace('/',File.separatorChar);
  
  /* *************************************************** */
  /* ALERT: Synchronize by hand with garbage.encodechars */
  /* *************************************************** */
  /* nahrazujeme nepratelske znaky */
  // urldir=urldir.replace(':','_');
  // zde to neni nutne, neb muze byt jen v portu
  
  //  urldir=urldir.replace('*','@');
  //  urldir=urldir.replace('?','#');  
  // urldir=urldir.replace('~','-');
  
  // these two are not needed. Browsers sends &lt; &gt;
  // urldir=urldir.replace('>','}');  
  // urldir=urldir.replace('<','{');
  urldir=urldir.replace('|','!');
  
  result.append(urldir);
  return result.toString();
}

/* U T I L I T Y */

final static String[] addStringToArray(String what,String[] array)
{
 //if(what==null) return array;
 if(array==null) { array=new String[1];array[0]=what;return array;}
 String[] tmp;
 int ar=array.length;
 tmp=new String[ar+1];
 System.arraycopy(array,0,tmp,0,ar);
 tmp[ar]=what;
 return tmp;
}

final static String[] reverseStringArray(String[] what)
{
 String res[];
 if(what==null) return null;
 res=new String[what.length];
 for(int i=0;i<what.length;i++)
  res[what.length-1-i]=what[i];

 return res;
}

final static regexp[] reverseRegexpArray(regexp[] what)
{
 regexp res[];
 if(what==null) return null;
 res=new regexp[what.length];
 for(int i=0;i<what.length;i++)
  res[what.length-1-i]=what[i];

 return res;
}

final static regexp[] addRegexpToArray(String what,regexp[] array)
{
 if(what==null) return array;
 if(array==null) { array=new regexp[1];array[0]=new regexp(what,true);return array;}
 /* test zda tam uz nejsme */
 for(int i=0;i<array.length;i++)
  if(array[i].matches(what)) { System.err.println("Rule "+what+" ignored.");return array;}
  
 regexp[] tmp;
 tmp=new regexp[array.length+1];
 System.arraycopy(array,0,tmp,0,array.length);
 tmp[array.length]=new regexp(what,!case_sensitive);
 return tmp;
}

final static boolean isInRegexpArray(String what,regexp[] array)
{
 if(array==null) return false;
 /* test zda tam uz nejsme */
 for(int i=0;i<array.length;i++)
  if(array[i].matches(what)) { return true;}
 return false;
}


final public static long[] incLongArraySize(long[] array)
{
 if(array==null) { array=new long[1];return array;}
 long[] tmp;
 tmp=new long[array.length+1];
 System.arraycopy(array,0,tmp,0,array.length);
 return tmp;
}

final public static float[] incFloatArraySize(float[] array)
{
 if(array==null) { array=new float[1];return array;}
 float[] tmp;
 tmp=new float[array.length+1];
 System.arraycopy(array,0,tmp,0,array.length);
 return tmp;
}


/* SIMPLE WILD CARD REGEXP */

/* hvezdicka muze byt jen na konci retezce */
/* TODO: predelat na regionmatches */

final public static String simpleWildMatch(String mask, String test)
{
 String lastmatch;
 if(mask==null) return test;
 int i=mask.indexOf('*',0);
 if(i==-1) {
            if(test.equals(mask)) return test;
             else
               return null;
           }
 int tl=test.length();
 int ml=mask.length();          
 if(i!=ml-1) throw new IllegalArgumentException("* is not at end of string "+mask);
 //if(test.startsWith(mask.substring(0,ml-1)))
 
 if(test.regionMatches(0,mask,0,ml-1))
 
  if (tl>=ml) return test.substring(ml-1);
          else
              return "";
  
 return null;
}

final public void garbage_collection()
{
 System.out.println(new Date()+" running garbage collection");
 garbage g=new garbage(cache_dir);
 g.garbage_collection();
 System.out.println(new Date()+" operation ended");
}

final public void fake_garbage_collection()
{
 System.out.println(new Date()+" [FAKE] running garbage collection");
 garbage g=new garbage(cache_dir);
 g.fake_garbage_collection();
 System.out.println(new Date()+" [FAKE] operation ended");
}

final public void kill_unref()
{
 System.out.println(new Date()+" killing unreferenced files");
 garbage g=new garbage(cache_dir);
 g.cleanup();
 System.out.println(new Date()+" operation ended");
}

public void converto020()
{
 System.out.println(new Date()+" converting cache control files to version 0.20");
 garbage g=new garbage(cache_dir);
 g.converto020();
 System.out.println(new Date()+" operation ended\nDO *** NOT *** RUN THIS OPERATION AGAIN OR YOUR DATA IN CACHE WILL BE DESTROYED!");
}

public void converto030()
{
 System.out.println(new Date()+" converting cache control files to version 0.30");
 garbage g=new garbage(cache_dir);
 g.converto030();
 System.out.println(new Date()+" operation ended");
}


final private boolean is_wild(String r)
{
 if(r.indexOf('*',0)==-1) return false;
  else
   return true;
}

final private boolean checkFlag(String f)
{
 if(f==null) return false;
 File fl=new File(f);
 if(fl.canRead() && fl.canWrite()) 
    {fl.delete();return true;}
 return false;
}

final static regexp[] parseRegexpFile(String fname,regexp fail[])
{
 try
 {
 String line,token;
 StringTokenizer st;
 DataInputStream dis=new DataInputStream(new BufferedInputStream(new FileInputStream(fname))); 
 while ( (line = dis.readLine()) != null)
 {
      if(line.startsWith("#")) continue;
      st=new StringTokenizer(line);
      if(st.hasMoreTokens()==false) continue;
      token=st.nextToken();
      if(token.equalsIgnoreCase("fail")||token.equalsIgnoreCase("pass"))
       {
        System.out.println(new Date()+" [WARNING] Stop using Fail/Pass keyword in fail/pass file.");
        if(st.hasMoreTokens()==false) continue;
        token=st.nextToken();
       }

       fail=addRegexpToArray(token,fail);
 }
 dis.close();
 
 
 }
 catch (IOException ioe)
  {
   System.out.println(new Date()+" I/O Error reading file "+fname);
  }
 return fail;
}

/* load block c00kie */

final static String[] parseCookieFile(String fname,String fail[])
{
 try
 {
 String line,token;
 StringTokenizer st;
 DataInputStream dis=new DataInputStream(new BufferedInputStream(new FileInputStream(fname))); 
 while ( (line = dis.readLine()) != null)
 {
      if(line.startsWith("#")) continue;
      st=new StringTokenizer(line);
      while(st.hasMoreTokens())
      {
        token=st.nextToken().toLowerCase();
        
        if(token.indexOf('*')>-1) 
         {
          System.out.println(new Date()+" [ERROR] Wildcards records are not supported in cookie_file");
          continue;
         } 
        else
         if(token.equals("all")) { return null;}
        fail=addStringToArray(token,fail);
        
      }
 }
 dis.close();
 
 
 }
 catch (IOException ioe)
  {
   System.out.println(new Date()+" I/O Error reading file "+fname);
  }
 return fail;
}


} /* class */