/*
 *  Smart Cache , http proxy caching server
 *  Copyright (C) 1998-9 Radim Kolar <hsn@cybermail.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA or
 *  download copy from http://www.gnu.org/copyleft/gpl.html
 *
 */

import java.util.*;
import java.io.File;

public class repair
{
 final static String guesstable[]=
           { 
             ".java","application/java",
             ".class","application/java-vm",
             ".gif","image/gif",
             ".jpg","image/jpeg",
             ".htm","text/html",
             ".html","text/html",
             ".jpeg","image/jpeg",
             ".zip","application/zip",
             ".txt","text/plain",
             ".doc","text/plain",
             ".log","text/plain",             
             ".tar","application/x-tar",
             ".pdf","application/pdf",
	     ".rtf","application/rtf",
	     ".au","audio/basic",
	     ".snd","audio/basic",
             ".mid","audio/midi",
             ".midi","audio/midi",
             ".mpga","audio/mpeg",
             ".mp2","audio/mpeg",
             ".mp3","audio/mpeg",
             ".aif","audio/x-aiff",
             ".aiff","audio/x-aiff",
             ".aifc","audio/x-aiff",
	     ".wav","audio/x-wav",
	     ".mpeg","video/mpeg",
	     ".mpg","video/mpeg",
             ".mpe","video/mpeg",
             ".qt","video/quicktime",
             ".mov","video/quicktime",
             ".avi","video/x-msvideo",
             ".movie","video/x-sgi-movie"
           };

 public static void main(String argv[])
 {
  System.out.println("Repair 0.2 - Simple .cacheinfo repairer and rebuilder");
  System.out.println("Repair utility for Smart Cache's control files. Copyright (c) Radim Kolar 1999");
  System.out.println("There is NO warranty. Don't expect miracles - ask god for it!\n");

  if(argv.length==0)
   {
     System.out.println("Syntax: repair <Directory...>");
     return;
   } 
  for(int i=0;i<argv.length;i++)
   repairDir(argv[i]);
 }

 public static void  repairDir(String dirname)
 {
   if(dirname==null) return;
   File f=new File(dirname);
   if(!f.exists())
    {
     System.out.println("[ERROR] Directory "+dirname+" don't needs any repair, becouse doesn't exists.");
     return;
    }
   
   if(!f.isDirectory())
    {
     //System.out.println("[ERROR] "+dirname+" is not a directory, no action done. ");
     int sep=dirname.lastIndexOf(File.separatorChar);
    if(sep==-1) dirname=".";
     else
    dirname=dirname.substring(0,sep);
    f=new File(dirname);
    // return;
    }
  if(!dirname.endsWith(File.separator)) dirname+=File.separatorChar;
    
  System.out.println("[START] Rebuilding directory "+dirname);
  cachedir cd;
  cd=new cachedir(dirname);
  cd.checkDir();
 
  String dirfilez[];
  String local[];
  Vector filez=new Vector();
  
  dirfilez=f.list();
  local=cd.listLocalNames();
  /* konverze dirfilez na vector */
  for(int i=dirfilez.length-1;i>=0;i--)
   filez.addElement(dirfilez[i]);
  dirfilez=null;

  /* smazat localnames z filez, abychom je nesmazali */
  for(int i=local.length-1;i>=0;i--)
   filez.removeElement(local[i]);
   
  filez.removeElement(cachedir.DIRINFO);
  // cd=null;
    
  local=null;
  /* projedeme filez a smazeme nalezene soubory */
  for(int i=filez.size()-1;i>=0;i--)
   {
    File df=null;
    try{
    df=new File(dirname+(String)filez.elementAt(i));
    }
    catch (ArrayIndexOutOfBoundsException z) {continue;}
    if(!df.isDirectory())
      {
       String ctype=guessContentType(df.toString());
       System.out.println("[INFO] Adding orphan file: "+df+" ct="+ctype);
       cacheobject co;
       String nm;
       nm=(String)filez.elementAt(i);
       if(nm.equals(mgr.DEFAULTNAME)) nm="";
       co=new cacheobject(nm,cd,(String)filez.elementAt(i),
       df.lastModified(),ctype,(int)df.length());
       cd.putObject(co);
       //df.delete();
       filez.removeElementAt(i);       
       i++;continue;
      }
   }
  cd.save();
  System.out.println("[OK] Rebuild done.\n");
 }
 
 public static String guessContentType(String fname)
 {
  fname=fname.toLowerCase();
  for(int i=0;i<guesstable.length;i+=2)
   {
    if(fname.endsWith(guesstable[i])) return guesstable[i+1];
   }
  System.out.println("[WARNING] Can not determine MIME type for "+fname+", defaulting to text/html");
  return "text/html";
 }
} 