/*
 *  Smart Cache , http proxy caching server
 *  Copyright (C) 1998-9 Radim Kolar <hsn@cybermail.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA or
 *  download copy from http://www.gnu.org/copyleft/gpl.html
 *
 */

import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.text.*;
import java.net.*;


/* chyby : pri POST posle HTTP1.0 hlavicku HTTP0.9 klientu */

public final class request{

/* quick abort config */
public static int qa_minlen, qa_maxlen;
public static String wafer;
public static float qa_percent;
public static long qa_maxtime;
public static char pnocache;
public static int read_timeout;
public static boolean cache_protected;
public static char referer_hack;
public static String default_forward_for;
public static boolean remove_pragma_no_cache;
public static DateFormat formatter= new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss 'GMT'", Locale.US);
public static String fake_user_agent, fake_referer;

/* agent.log */
public static String alogpatterns[];
public static DataOutputStream alogfilez[];
public static String alogfilenames[];

/* referer.log */
public static String rlogpatterns[];
public static DataOutputStream rlogfilez[];
public static String rlogfilenames[];

public static boolean full_referer_log;

private String URL;
private int method;
private DataInputStream in; /* klient input */
private DataOutputStream out; /* klient output */
private boolean http10;

private boolean cacheable;

private long ims; /* if modified since */
private long exp; /* expires */

private boolean hasCookie;
private int ctsize;
private String ctype;
private String location;
private boolean reload;
private Vector headers;
private boolean host;
private int httprc;
private String protocol; /* ftp, gopher, ... */

private int proxyport;
private InetAddress proxyhost;

request(int met,String url,Vector head,DataInputStream in,DataOutputStream out) throws MalformedURLException
{
 hasCookie=false;
 ims=httprc=0;
 ctsize=-1;
 reload=false;
 cacheable=true;
 this.method=met;
 protocol=null;
 ctype=null;
 
 // if(met<httpreq.REQUEST_MIN || met>httpreq.REQUEST_MAX) throw new NullPointerException("Bad Method");
 URL=url;
 if(head==null) { http10=false; headers=new Vector();}
  else
   { http10=true;
     headers=head;}
 this.in=in;
 this.out=out;
 
 host=false; /* host hlavicka */
 /* projdeme hlavicky, zajima nas Pragma: no-cache 
  a if-modified-since
 */
 int i,j;
 String s,s1,s2,hosth;
 hosth=null;
 char rhcache;
 if(fake_referer!=null || rlogpatterns!=null) rhcache=99; else rhcache=referer_hack;
 int cachedsize=headers.size();
 for(i=0;i<cachedsize;i++)
 {
    s=(String)headers.elementAt(i);
    j=s.indexOf(':',0);
    if(j==-1) continue;
    s1=s.substring(0,j).toLowerCase();
    s2=s.substring(j+1).trim();
//  System.out.println("Header = "+s1);
    if(s1.equals("pragma"))
           {
           if (s2.equalsIgnoreCase("no-cache")) { reload=true;}
           if (remove_pragma_no_cache) { headers.removeElementAt(i--);cachedsize--;}
           continue;
           }
    if(s1.equals("host")) { host=true; hosth=s2;continue;}
    if(s1.equals("content-length")) { ctsize=Integer.valueOf(s2).intValue(); continue;}    
    if(s1.equals("if-modified-since")) {
                                        /* cut of file size */
                                        j=s2.indexOf(';',0);
                                        if(j>-1) s2=s2.substring(0,j); 
                                        ims=new Date(s2).getTime();
                                        headers.removeElementAt(i--);
                                        cachedsize--;
                                        continue;
                                     // System.out.println("IMS="+ims);
                                      }
    /* kill possible Keep-Alive */                                      
    if(s1.equals("connection")) {      
                                        headers.removeElementAt(i--);
                                        cachedsize--;
                                        continue;
                                      }

    if(s1.equals("proxy-connection")) {      
                                        headers.removeElementAt(i--);
                                        cachedsize--;
                                        continue;
                                      }
    if(hasCookie==false && s1.equals("cookie")) 
                                      {
                                       hasCookie=true;
                                       continue;
                                      }
    if(s1.equals("authorization")) {
                                        cacheable=cache_protected; // was false;
                                        continue;
                                      }
                                      
                                      
    if(s1.equals("user-agent")) {       
                                  /* agent.log enabled? */
                                  if(alogpatterns!=null)
                                  {
                                    int j1=alogpatterns.length;
                                    for(int ii=0;ii<j1;ii++)
                                    {
                                       String fragment;
                                       fragment=mgr.simpleWildMatch(alogpatterns[ii], url);
                                       if(fragment==null) continue;
                                       DataOutputStream output;
                                       output=alogfilez[ii];
                                       if(output==null && alogfilenames[ii]!=null)
                                          /* OPEN LOGFILE */
                                          if(!httpreq.open_logfile(alogfilenames,alogfilez,ii)) break;
                                           else
                                            output=alogfilez[ii];
                                       try
                                       {
                                        synchronized (output)
                                        {
                                         output.writeBytes(s2);
                                         output.writeByte('\n');
                                        }
                                       }
                                       catch (IOException zz1)
                                        {
                                         alogfilenames[ii]=null;
                                        }
                                       break;

                                    } /* log for */
                                  } /* alog enabled? */
    
                                        if(fake_user_agent!=null)
                                           s=fake_user_agent;
                                         else
                                           s+=" via "+scache.VERSION;
                                        headers.setElementAt(s,i);
                                        continue;
                                      }
    if(rhcache>0 && s1.equals("referer")) {
    
                                  /* referer.log enabled? */
                                  if(rlogpatterns!=null)
                                  {
                                    int j1=rlogpatterns.length;
                                    for(int ii=0;ii<j1;ii++)
                                    {
                                       String fragment;
                                       fragment=mgr.simpleWildMatch(rlogpatterns[ii], url);
                                       if(fragment==null) continue;
                                       if(full_referer_log==false)
                                        { /* mini referer - log */
                                         int z=url.indexOf("://");
                                         if(z==-1) break;
                                         int z2=url.indexOf('/',z+3);
                                         if(z2!=-1)
                                           if (s2.regionMatches(0,url,0,z2)) break;
                                             else ;
                                          else
                                           if(s2.regionMatches(0,url,0,url.length())) break;
                                             
                                        }
                                       DataOutputStream output;
                                       output=rlogfilez[ii];
                                       if(output==null && rlogfilenames[ii]!=null)
                                          /* OPEN LOGFILE */
                                          if(!httpreq.open_logfile(rlogfilenames,rlogfilez,ii)) break;
                                           else
                                            output=rlogfilez[ii];
                                       try
                                       {
                                        synchronized(output)
                                        {
                                         output.writeBytes(s2+" -> "+url);
                                         output.writeByte('\n');
                                        }
                                       }
                                       catch (IOException zz1)
                                        {
                                         rlogfilenames[ii]=null;
                                        }
                                       break;

                                    } /* log for */
                                  } /* alog enabled? */
    
                                        if(rhcache==1)  
                                         { headers.removeElementAt(i--);cachedsize--;rhcache=0;continue;}
                                        else
                                          if (rhcache==99)
                                            s="Referer: "+fake_referer;
                                          else
                                            s="Referer: "+url;
                                            
                                        headers.setElementAt(s,i);
                                        rhcache=0; /* turn it off! */
                                        continue;
                                      }
                                                                                                                                                        
 }
 /* pokud jsme http 0.9 tak pridame accept hlavicku */
 if(!http10) headers.addElement("Accept: */*");
 /* pro jistotu */
 // headers.addElement("Connection: close");
 
/* - F O R W A R D E R - */

 if(url.charAt(0)=='/')
  {
   /* fire-up forwarder! */
   protocol="http";
   if(hosth!=null) URL="http://"+hosth+url;
           else
                   URL="http://"+default_forward_for+url;
   return;
  }
 
 /* extract protocol */
 
 int pos=url.indexOf("://",0);
 if(pos==-1) throw new MalformedURLException();
 protocol=url.substring(0,pos);
 
 /* check for losername/password */
 try
 {
  int zav=url.indexOf('@',pos+3);
  if(zav>0)
   {
    /*   @   / - ok     */ 
    /*   /  @ - ignore  */
    /*   @    - ok      */
    int slash=url.indexOf('/',pos+3);
    if( slash>zav || slash==-1 )
    {
     String auth="Authorization: Basic "+HTUU.encode_string(url.substring(pos+3,zav));
     headers.addElement(auth);
     URL=protocol+"://"+url.substring(zav+1); // remove auth string from URL
     // System.err.println("new URL="+URL);
    }
   }
 }
 catch (Exception e) 
   { throw new MalformedURLException();} // So no need to check index out of bounds
 
 /* test zda je to HTTP proxy request */ 
 /*
 char c;
 c=url.charAt(0);
 if(c!='h' && c!='H') throw 
 if(url.charAt(4)!=':') throw new MalformedURLException();  
 */
}

final public void rewriteURL(String newURL)
{
 this.URL=newURL;
 char rhcache=referer_hack;
 if(!host && rhcache<2) return;
 // scan and kill old host header
 String s,s1;
  int cachedsize=headers.size();

  for(int i=0;i<cachedsize;i++)
 {  
    int j;
    s=(String)headers.elementAt(i);
    j=s.indexOf(':',0);
    if(j==-1) continue;
    s1=s.substring(0,j).toLowerCase();
    // s2=s.substring(j+1).trim();
    if(s1.equals("host")) {      
                            headers.removeElementAt(i--);
                            cachedsize--;
                            continue;
                           }
    if(rhcache>0 && s1.equals("referer")) {
                                            s="Referer: "+newURL;
                                            headers.setElementAt(s,i);
                                          
                                            rhcache=0; /* turn it off! */
                                            continue;
                                      }
    
 }
 host=false;
}

final public void removeCookies()
{
 if(hasCookie==false) return;
 // scan and kill c00kie header
  String s,s1;
  int cachedsize=headers.size();

  for(int i=0;i<cachedsize;i++)
 {  
    int j;
    s=(String)headers.elementAt(i);
    j=s.indexOf(':',0);
    if(j==-1) continue;
    s1=s.substring(0,j).toLowerCase();
    // s2=s.substring(j+1).trim();
    if(s1.equals("cookie")) {      
                            if(wafer==null)
                              {
                                headers.removeElementAt(i--);
                                cachedsize--;
                              }
                              else
                              {headers.setElementAt(wafer,i);}
                            continue;
                           }
    
 }
}


final public void addHost(String hostname,String port)
{
 if(host) return; /* uz ji mame - nemenime */
 if(port==null)  headers.addElement("Host: "+hostname);
  else
   headers.addElement("Host: "+hostname+":"+port);
  
 host=true;
}

final public int getMethod()
{
 return method;
}

final public boolean requestReload()
{
 return reload;
}
final public String getURL()
{
 return URL;
}

/* nastavi cil - proxy nebo cilovy server, to je jedno */
final public void setTarget(InetAddress proxyhost, int proxyport)
{
 this.proxyhost=proxyhost;
 this.proxyport=proxyport;
}

final public Socket connectToHost() throws IOException
{
 Socket s;
 if(proxyhost==null) throw new IOException("Host unknown");
 s=new Socket(proxyhost,proxyport);
 s.setSoTimeout(read_timeout);
 return s;
}

final public void handle_post() throws IOException
{
 Socket toserver=null;
 try{
  toserver=connectToHost();
 }
 catch (IOException e)
  { send_error(400,"Connect to server failed. POST request canceled.");return; }
 try{
 DataInputStream sin=new DataInputStream (new BufferedInputStream(toserver.getInputStream()));
 DataOutputStream sou=new DataOutputStream(new BufferedOutputStream(toserver.getOutputStream()));
 send_request(sou);
 
 /* pokud nemame ctsize, tak cteme az na konec */
 /* precteme data z klienta a odesleme je na server */
 
 while(ctsize!=0)
 {
//  System.out.println(ctsize);
  byte b[]=new byte[512];
  int rb;
  if(ctsize<0) rb=in.read(b); 
         else
          rb=in.read(b,0,Math.min(ctsize,512)); 
  if(rb==-1) break; /* konec dat! */
  ctsize-=rb;
  sou.write(b,0,rb);
 }
 sou.writeByte(0); // Zbynek Pospichal lamer detector
 sou.flush();
 
 /* otocime to, cteme data ze serveru a posilame je klientu */
 while(true)
 {
  byte b[]=new byte[512];
  int rb;
  rb=sin.read(b); 
  if(rb==-1) break; /* konec dat! */
  out.write(b,0,rb);
 }
 
 sou.close();
 sin.close();
 toserver.close(); 
 /* zavrit klienta */
 out.close();
 in.close();
 }
 catch (IOException e1) { toserver.close();}
}

final public void send_request(DataOutputStream sout) throws IOException
{
 String met=null;
 if(method==httpreq.REQUEST_GET) met="GET";
 else
 if (method==httpreq.REQUEST_POST) met="POST";
 else
 if (method==httpreq.REQUEST_HEAD) met="HEAD";
 else 
  send_error(500,"Internal cache error");
 
 sout.writeBytes(met+" "+URL+" HTTP/1.0\r\n");
 
 int hscache=headers.size();
 for(int i=0;i<hscache;i++)
   { sout.writeBytes((String)headers.elementAt(i));
     sout.writeBytes("\r\n");
   }
 sout.writeBytes("\r\n");  
 sout.flush();
}

final public void close() throws IOException
{
 out.close();
 in.close();
}

/* precte &parse hlavicky ze serveru */
final public void read_headers(DataInputStream in) throws IOException
{
 headers=new Vector();
 ims=exp=0; /* pro last modified */
 ctsize=-1;
 // ctype="application/octet-stream";
 ctype="text/html"; // like Mozilla does
 reload=false; /* pouzivano pro pragma: no-cache */
 String line;
 line=in.readLine(); /* HTTP/1.0 XX OK */
 if(line==null) 
                  try{
                        in.close();
                     }
                  catch(IOException e) {}
                  finally
                  { throw new IOException("Cannot read http return code");}
                  
 /* precteme si tedy kod */
 StringTokenizer st;
 st=new StringTokenizer(line);
 /* tady to spadne pri remote HTTP 0.9 serveru */
 try
 {
   st.nextToken(); /* http/1.0 - nezajimave */
   httprc=Integer.valueOf(st.nextToken()).intValue();
 }
 catch (Exception http09)
 {
  send_error(501,"Remote servers talking with old HTTP 0.9 protocol are not supported.");return; 
 }
 
 /* cteme hlavicky */
  while(true)
    { 
      int j;
      String s1,s2;
      line=in.readLine();
      if(line==null) break;
      if(line.length()==0) break;
      headers.addElement(line);
    j=line.indexOf(':',0);
    if(j==-1) continue;
    s1=line.substring(0,j).toLowerCase();
    s2=line.substring(j+1).trim();
    if(s1.equals("pragma") && s2.equalsIgnoreCase("no-cache")) { reload=true;continue;}
    if(s1.equals("content-length")) 
             try
              {
                 ctsize=Integer.valueOf(s2).intValue(); 
              }
              catch (Exception ignore)
              {}
              finally
              { continue;}    
              
    if(s1.equals("content-type")) { ctype=s2; continue;}    
    if(s1.equals("location")) { location=s2; continue;}        
    
    if(s1.equals("last-modified")) {     
                                        try{
                                        ims=new Date(s2).getTime();
                                        }
                                        catch (IllegalArgumentException e)
                                         { ims=0;}
                                        continue;
                                      }

    if(s1.equals("expires")) {          try{
                                        exp=new Date(s2).getTime();
                                        }
                                        catch (IllegalArgumentException e)
                                         { exp=1;}
                                        continue;
                                      }
                                      
                                                                            
                                      
 } /* hlavicky */
 if(method!=httpreq.REQUEST_GET) cacheable=false;
 if(exp!=0 && exp<=System.currentTimeMillis()) {exp=0;reload=true;} /* stejne jako PNC */
 // System.out.println(cacheable+" "+reload);
 if(!cacheable) { reload=true;return;}
 if(!reload) {
               // System.out.println(ims+" "+cacheobject.generate_lastmod);
              
               if(cacheobject.generate_lastmod==2 && ims==0 )
                {
                 // System.err.println("Adding lastmod header!");
                 headers.addElement("Last-Modified: "+printDate(new Date()));
                }
               return;
             }
 
 /* pokud je P-N-C nebudeme last-modified hlavicku pridavat */
 switch(pnocache)
 {
  case 1: reload=false;break;
  case 2: if(ctype.startsWith("image")) reload=false;break;
  case 3: if(!ctype.startsWith("text")) reload=false;break;
 }
} /* procedura */

final public void transfer_object(DataInputStream sin, DataOutputStream file,cachedir dir) throws IOException
{
 int read=0;
 int i;
 long whenaborted;
 boolean clientdead;
 byte b[]=new byte[4096];
 clientdead=false;
 whenaborted=0;
 while(true)
 {
  /* precist */
  try{
  i=sin.read(b);
  }
  catch (IOException e) { if(file!=null) file.close(); 
                          throw e;
                        }
  if(i==-1) break; /* koncime */
  
  read+=i;
  if(file!=null) { dir.setDirty();file.write(b,0,i);}
  
  /* zapisovat do klienta opatrne! */
  try{
  if(!clientdead) out.write(b,0,i);
   else
    if(qa_minlen==-1 && System.currentTimeMillis()-whenaborted>qa_maxtime) 
                            { sin.close();
                            // System.out.println("Transfer of "+this.URL+" terminated. (aborted transfer time exceed)");
                            throw new IOException("Aborted by timeout");}
  }
  catch(IOException e) { if(file==null) { sin.close();throw e; }
                         if(CheckQuickAbort(read)) { file.close();sin.close();throw e;}
                         // System.out.println("client-close!");
                         clientdead=true;
                         whenaborted=System.currentTimeMillis();
                         }
 } 
 sin.close();
 
 try{
 out.close();
 }
 catch (IOException e) {}
 
 if(file!=null) file.close();
 
 if(ctsize!=-1 && read<ctsize) throw new IOException("Object too small");
 // waz !=ctsize
 ctsize=read;
}

/* add if-mod-since header */
final public void add_ims()
{
 add_ims(ims);
}

final public void add_ims(long when)
{
 if(when==0) return;
 headers.insertElementAt("If-Modified-Since: "+printDate(new Date(when)),0); 
}

final public int getRc()
{
 return httprc;
}

/* odesle obdrzene hlavicky od serveru klientu */
final public void send_headers()
{
 if(!http10) return;
 try{
 out.writeBytes("HTTP/1.0 "+httprc+" OK\r\n");
 int headerscache=headers.size();
 for(int i=0;i<headerscache;i++)
   { out.writeBytes((String)headers.elementAt(i));
     out.writeBytes("\r\n");
   }
 out.writeBytes("\r\n");  
 out.flush();
 }
 catch (IOException e)
   {
    try{
    out.close();
    }
    catch (Exception e1) {}
   }
}

final public void make_headers(int rc,String ctype,String loc,int sz,long lm,long exp)
{
 httprc=rc;
 headers=new Vector();
 Date d=new Date();
 if(ctype!=null) headers.addElement("Content-type: "+ctype);
 if(sz>0) headers.addElement("Content-length: "+sz);
 headers.addElement("Date: "+printDate(d));
 if(lm!=0) headers.addElement("Last-Modified: "+printDate(new Date(lm)));
 
 /* don't send Expired expires ???
 if(exp>d.getTime()) headers.addElement("Expires: "+printDate(new Date(exp)));
 */
 if(exp>0) headers.addElement("Expires: "+printDate(new Date(exp)));
 if(loc!=null) headers.addElement("Location: "+loc);
 headers.addElement("Server: "+scache.VERSION);
 /* FIN2 !! */
 headers.addElement("Connection: close");
 headers.addElement("Proxy-Connection: close");
}

final public void setRequestTo(String URL)
{
 this.URL=URL;
}

final public long getIms()
{
 return ims;
}

final public long getExpires()
{
 return exp;
}


final public void clearIms()
{
 ims=0;
}

final public String getCtype()
{
 return ctype;
}

final public int getCsize()
{
 return ctsize;
}

final public String getLocation()
{
 return location;
}

final public void send_error(int errorrc,String msg) throws IOException
{
 httpreq.server_error(http10,errorrc,msg, out);
}


/* return true if the request should be aborted */

/* pokud se neuklada tak abortnout bez ptani! */
final private boolean
CheckQuickAbort(int readb)
{
    if (reload) return true;
//  if (BIT_TEST(icpState->entry->flag, KEY_PRIVATE))
//  return 1;

    if (qa_minlen < 0)
	/* disabled */
	return false;

    if(ctsize!=-1)
    {        
    if (readb > ctsize)
	/* bad content length */
	return true;
    
    if ((ctsize - readb) < qa_minlen)
	/* only little more left */
	return false;
    if ((ctsize - readb) > qa_maxlen)
	/* too much left to go */
	return true;
    if ( (float)readb / ctsize > qa_percent)
	/* past point of no return */
	return false;
    }
    return true; /* ZASTAVIT STROJE ! */
    
    /*
    return false;  no dobra povolime to, ale vypadne to na timeout nebo
    na pocet dat */
}

final public static String printDate(Date d)
{

 // DateFormat formatter= new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss 'GMT'", Locale.US);
 try
  {
   return formatter.format(d);
  }
 catch (Exception z)
  {
   z.printStackTrace();
   System.out.println("[JAVA_INTERNAL_ERROR] SimpleDateFormat.format(d) failed\nDate format=EEE, dd MMM yyyy HH:mm:ss 'GMT' BadDate(formated)="+d+" time(long)="+d.getTime()+" THIS IS A JAVA BUG.\nREPORT TO      http://java.sun.com/cgi-bin/bugreport.cgi");
  }
  return null;
 
 /*
 String res;
 if(d==null) return "";
 switch(d.getDay())
 {
 case 0: res="Sun, ";break;
 case 1: res="Mon, ";break;
 case 2: res="Tue, ";break;
 case 3: res="Wed, ";break;
 case 4: res="Thu, ";break;
 case 5: res="Fri, ";break;
 case 6: res="Sat, ";break;
 }
 if(d.getDate()<10) res+="0";
 res+=d.toGMTString();
 return res;
 */
}

final public boolean canCache()
{
 return cacheable;
}

final public void nocache()
{
 cacheable=false;
}

final public void sendString(String arg) throws IOException
{
 out.writeBytes(arg);
 // out.flush();
}

/*
public void cachethis()
{
 cacheable=true;
}
*/

public final String getProtocol()
{
 return protocol;
}

}