/*
 *  Smart Cache , http proxy caching server
 *  Copyright (C) 1998-9 Radim Kolar <hsn@cybermail.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA or
 *  download copy from http://www.gnu.org/copyleft/gpl.html
 *
 */

import java.io.*;
import java.util.*;
import java.net.*;

public final class scache{

public static String VERSION;

public final static String CACHENAME="Smart Cache";
public final static String CACHEVER="0.40";
public static boolean faststart;

public static int MAXHTTPCLIENTS=25; // prevent overload by cdrop attacks

private transient ServerSocket server;
// private transient volatile boolean listening;

public static void main(String argv[]) throws IOException
{
 faststart=false;
 // InetAddress.addressCache=new Hashtable();
 
// System.runFinalizersOnExit(true);
 VERSION=CACHENAME+" "+CACHEVER;
 
 System.err.println(VERSION+" - full featured caching proxy server and web forwarder\n"+
 "Copyright (c) Radim Kolar 1998-9.  This is FREE software; There is NO warranty.\n"+
 "See the GNU General Public Licence version 2 or later for copying conditions.\n");
 
 mgr m=new mgr();
 m.read_config("scache.cnf");
 
 System.err.println(
"\"I was born in the darkest ignorance, and my spiritual master pierced my eyes\n"+
"with the torch of knowledge. I offer my respectful obeisances unto him.\"\n\t\t\t\tSri Guru Pranama");

 if(argv.length>0)
  {
    if(argv[0].equals("-killunref"))  m.kill_unref();
     else
    if(argv[0].equals("-gc"))  m.garbage_collection();
     else
    if(argv[0].equals("-fakegc"))  m.fake_garbage_collection();
     else
    if(argv[0].equals("-convert020"))  m.converto020();
     else
    if(argv[0].equals("-convert030"))  m.converto030();
     else
    if(argv[0].equals("-faststart"))  { faststart=true;m.go();}
     else
    if(argv[0].equals("-local"))  { 
                                    m.parentproxy=InetAddress.getByName("127.0.0.1");
                                    m.port=4;
                                    m.no_proxy=null;
                                    System.err.println("Smart Cache set to FORCED LOCAL MODE. Will not connect to any remote site.");
                                    m.go();
                                  }
     else
      System.err.println("usage: scache [ -option ]\n\nWhere option is ONE of:"
      +"\n\t-gc\t\tRun garbage collector and exit"
      +"\n\t-local\t\tRun cache in forced local mode - needed for avoiding DNS or connect timeout on bugy TCP configurations"
      +"\n\t-convert020\tConverts cache control files to version 0.20"
      +"\n\t-convert030\tConverts cache directory to version 0.30"
      +"\n\t-faststart\tDon't check for latest version and Ad busters ruleset (now allways enabled)\n"
      +"\nAbsolete or debugging options:\n"
      +"\n\t-killunref\tAbsolete, use -gc instead. Remove bad and inaccessible files from cache"
      +"\n\t-fakegc\t\tRun garbage collection, but don't delete anything from cache (usefull only for debug)"
      +"\n\nFor more information see http://ncic.netmag.cz/apps/nase/smartcache.html"

      );
  }
 else
  m.go();
}


scache(int port,InetAddress adr) throws IOException
{
 if(adr!=null)
 
  try{
  server=new ServerSocket(port,10,adr);
  }
  catch(IOException e) {System.err.println("Cannot bind to my port "+port+"/"+adr.getHostAddress());throw e;}
   else
  try{
    server=new ServerSocket(port);
  }
  catch(IOException e) {System.err.println("Cannot bind to my port "+port+"/*");throw e;}
   
}

public final void httpdloop()
 {
  // listening=true;
  ThreadGroup clients;
  httpreq client;
  clients=new ThreadGroup("HTTP-clients");
//  clients.setDaemon(true);
   while (true ) {
            Socket clientSocket = null;
            client=null;
            try {
                clientSocket = server.accept();
                } catch (IOException e) {
                System.err.println("Accept failed: "+e);
                continue;
            }
            if(clients.activeCount()>MAXHTTPCLIENTS) 
              try {
              System.err.println(new Date()+" Active clients limit ("+MAXHTTPCLIENTS+") reached, kicking off.");
              clientSocket.close();}
              catch(IOException e) {}
              finally { continue;}
            client=new httpreq(clientSocket);
            new Thread(clients,client).start();
   }  /* listen */
   
    /*
   try{
   server.close();
   }
   catch(Exception e) {}
  
   System.out.println("Terminating httpd subsystem...");
   
   while(clients.activeCount()>0)
    ;
   System.out.println("httpd subsystem terminated.");
   clients.destroy();
   */
 }


} /* class scache*/